Index: /LMDZ6/trunk/libf/phylmd/pbl_surface_mod.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/pbl_surface_mod.F90	(revision 3887)
+++ /LMDZ6/trunk/libf/phylmd/pbl_surface_mod.F90	(revision 3888)
@@ -26,8 +26,8 @@
   USE cdrag_mod
   USE stdlevvar_mod
-  USE wx_pbl_mod,          ONLY : wx_pbl_init, wx_pbl_final, &
-!!                                  wx_pbl_fuse_no_dts, wx_pbl_split_no_dts, &
-!!                                  wx_pbl_fuse, wx_pbl_split
-                                  wx_pbl0_fuse, wx_pbl0_split
+  USE wx_pbl_var_mod,      ONLY : wx_pbl_init, wx_pbl_final, &
+                                  wx_pbl_prelim_0, wx_pbl_prelim_beta
+  USE wx_pbl_mod,          ONLY : wx_pbl0_merge, wx_pbl_split, wx_pbl_dts_merge, &
+                                  wx_pbl_check, wx_pbl_dts_check, wx_evappot
   use config_ocean_skin_m, only: activate_ocean_skin
 
@@ -37,10 +37,13 @@
   REAL, ALLOCATABLE, DIMENSION(:), PRIVATE, SAVE     :: fder   ! flux drift
   !$OMP THREADPRIVATE(fder)
-  REAL, ALLOCATABLE, DIMENSION(:,:), PUBLIC, SAVE   :: snow   ! snow at surface
+  REAL, ALLOCATABLE, DIMENSION(:,:), PUBLIC, SAVE    :: snow   ! snow at surface
   !$OMP THREADPRIVATE(snow)
   REAL, ALLOCATABLE, DIMENSION(:,:), PRIVATE, SAVE   :: qsurf  ! humidity at surface
   !$OMP THREADPRIVATE(qsurf)
-  REAL, ALLOCATABLE, DIMENSION(:,:,:), SAVE :: ftsoil ! soil temperature
+  REAL, ALLOCATABLE, DIMENSION(:,:,:), SAVE          :: ftsoil ! soil temperature
   !$OMP THREADPRIVATE(ftsoil)
+  REAL, ALLOCATABLE, DIMENSION(:), SAVE              :: ydTs0, ydqs0  
+                                                     ! nul forced temperature and humidity differences
+  !$OMP THREADPRIVATE(ydTs0, ydqs0)
 
   INTEGER, SAVE :: iflag_pbl_surface_t2m_bug
@@ -99,8 +102,16 @@
     IF (ierr /= 0) CALL abort_physic('pbl_surface_init', 'pb in allocation',1)
 
+    ALLOCATE(ydTs0(klon), stat=ierr)
+    IF (ierr /= 0) CALL abort_physic('pbl_surface_init', 'pb in allocation',1)
+
+    ALLOCATE(ydqs0(klon), stat=ierr)
+    IF (ierr /= 0) CALL abort_physic('pbl_surface_init', 'pb in allocation',1)
+
     fder(:)       = fder_rst(:)
     snow(:,:)     = snow_rst(:,:)
     qsurf(:,:)    = qsurf_rst(:,:)
     ftsoil(:,:,:) = ftsoil_rst(:,:,:)
+    ydTs0(:) = 0.
+    ydqs0(:) = 0.
 
 !****************************************************************************************
@@ -183,4 +194,7 @@
        ts,SFRWL,   alb_dir, alb_dif,ustar, u10m, v10m,wstar, &
        cdragh,    cdragm,   zu1,    zv1,              &
+!jyg<   (26/09/2019)
+       beta, &
+!>jyg
        alb_dir_m,    alb_dif_m,  zxsens,   zxevap,    &
        alb3_lic,  runoff,    snowhgt,   qsnow,     to_ice,    sissnow,  &
@@ -206,5 +220,6 @@
        s_therm,   s_trmb1,   s_trmb2,  s_trmb3,       &
        zustar,zu10m,  zv10m,    fder_print,    &
-       zxqsurf,   rh2m,      zxfluxu,  zxfluxv,       &
+       zxqsurf, delta_qsurf,                       &
+       rh2m,      zxfluxu,  zxfluxv,               &
        z0m, z0h,   agesno,  sollw,    solsw,         &
        d_ts,      evap,    fluxlat,  t2m,           &
@@ -366,4 +381,7 @@
 ! Input/Output variables
 !****************************************************************************************
+!jyg<
+    REAL, DIMENSION(klon, nbsrf), INTENT(INOUT)     :: beta    ! Aridity factor
+!>jyg
     REAL, DIMENSION(klon, nbsrf), INTENT(INOUT)     :: ts      ! temperature at surface (K)
     REAL, DIMENSION(klon, nbsrf), INTENT(INOUT)     :: delta_tsurf !surface temperature difference between
@@ -468,4 +486,5 @@
     REAL, DIMENSION(klon),        INTENT(OUT)       :: fder_print ! fder for printing (=fder(i) + dflux_t(i) + dflux_q(i))
     REAL, DIMENSION(klon),        INTENT(OUT)       :: zxqsurf    ! humidity at surface, mean for each grid point
+    REAL, DIMENSION(klon),        INTENT(OUT)       :: delta_qsurf! humidity difference at surface, mean for each grid point
     REAL, DIMENSION(klon),        INTENT(OUT)       :: rh2m       ! relative humidity at 2m
     REAL, DIMENSION(klon, klev),  INTENT(OUT)       :: zxfluxu    ! u wind tension, mean for each grid point
@@ -540,8 +559,10 @@
     REAL, DIMENSION(klon)              :: r_co2_ppm     ! taux CO2 atmosphere
     REAL, DIMENSION(klon)              :: yts, yz0m, yz0h, ypct
+    REAL, DIMENSION(klon)              :: yz0h_old
 !albedo SB >>>
     REAL, DIMENSION(klon)              :: yalb,yalb_vis
 !albedo SB <<<
     REAL, DIMENSION(klon)              :: yt1, yq1, yu1, yv1
+    REAL, DIMENSION(klon)              :: yqa
     REAL, DIMENSION(klon)              :: ysnow, yqsurf, yagesno, yqsol
     REAL, DIMENSION(klon)              :: yrain_f, ysnow_f
@@ -577,8 +598,9 @@
     REAL, DIMENSION(klon)              :: yz0h_oupas
     REAL, DIMENSION(klon)              :: yfluxsens
+    REAL, DIMENSION(klon)              :: AcoefH_0, AcoefQ_0, BcoefH_0, BcoefQ_0
     REAL, DIMENSION(klon)              :: AcoefH, AcoefQ, BcoefH, BcoefQ
     REAL, DIMENSION(klon)              :: AcoefU, AcoefV, BcoefU, BcoefV
     REAL, DIMENSION(klon)              :: ypsref
-    REAL, DIMENSION(klon)              :: yevap, ytsurf_new, yalb3_new
+    REAL, DIMENSION(klon)              :: yevap, yevap_pot, ytsurf_new, yalb3_new
 !albedo SB >>>
     REAL, DIMENSION(klon,nsw)          :: yalb_dir_new, yalb_dif_new
@@ -592,5 +614,5 @@
     REAL, DIMENSION(klon,klev)         :: y_flux_u, y_flux_v
     REAL, DIMENSION(klon,klev)         :: ycoefh, ycoefm,ycoefq
-    REAL, DIMENSION(klon)              :: ycdragh, ycdragm
+    REAL, DIMENSION(klon)              :: ycdragh, ycdragq, ycdragm
     REAL, DIMENSION(klon,klev)         :: yu, yv
     REAL, DIMENSION(klon,klev)         :: yt, yq
@@ -624,5 +646,6 @@
     REAL, DIMENSION(klon,klev)         :: ycoefh_x, ycoefm_x, ycoefh_w, ycoefm_w
     REAL, DIMENSION(klon,klev)         :: ycoefq_x, ycoefq_w
-    REAL, DIMENSION(klon)              :: ycdragh_x, ycdragm_x, ycdragh_w, ycdragm_w
+    REAL, DIMENSION(klon)              :: ycdragh_x, ycdragh_w, ycdragq_x, ycdragq_w
+    REAL, DIMENSION(klon)              :: ycdragm_x, ycdragm_w
     REAL, DIMENSION(klon)              :: AcoefH_x, AcoefQ_x, BcoefH_x, BcoefQ_x
     REAL, DIMENSION(klon)              :: AcoefH_w, AcoefQ_w, BcoefH_w, BcoefQ_w
@@ -645,5 +668,8 @@
     REAL                               :: zx_qs_surf, zcor_surf, zdelta_surf
     REAL, DIMENSION(klon)              :: ytsurf_th, yqsatsurf
+!jyg<
     REAL, DIMENSION(klon)              :: ybeta
+    REAL, DIMENSION(klon)              :: ybeta_prev
+!>jyg
     REAL, DIMENSION(klon, klev)        :: d_u_x
     REAL, DIMENSION(klon, klev)        :: d_u_w
@@ -780,5 +806,14 @@
 !!! nrlmd le 13/06/2011
     REAL, DIMENSION(klon)              :: y_delta_flux_t1, y_delta_flux_q1, y_delta_flux_u1, y_delta_flux_v1
-    REAL, DIMENSION(klon)              :: y_delta_tsurf,delta_coef,tau_eq
+    REAL, DIMENSION(klon)              :: y_delta_tsurf, y_delta_tsurf_new
+    REAL, DIMENSION(klon)              :: delta_coef, tau_eq
+    REAL, DIMENSION(klon)              :: HTphiT_b, dd_HTphiT, HTphiQ_b, dd_HTphiQ, HTRn_b, dd_HTRn
+    REAL, DIMENSION(klon)              :: phiT0_b, dphiT0, phiQ0_b, dphiQ0, Rn0_b, dRn0
+    REAL, DIMENSION(klon)              :: y_delta_qsurf
+    REAL, DIMENSION(klon)              :: y_delta_qsats
+    REAL, DIMENSION(klon)              :: yg_T, yg_Q
+    REAL, DIMENSION(klon)              :: yGamma_dTs_phiT, yGamma_dQs_phiQ
+    REAL, DIMENSION(klon)              :: ydTs_ins, ydqs_ins
+!
     REAL, PARAMETER                    :: facteur=2./sqrt(3.14)
     REAL, PARAMETER                    :: inertia=2000.
@@ -793,5 +828,7 @@
     REAL, DIMENSION(klon)              :: Kech_m
     REAL, DIMENSION(klon)              :: Kech_m_x, Kech_m_w 
-    REAL, DIMENSION(klon)              :: yts_x,yts_w
+    REAL, DIMENSION(klon)              :: yts_x, yts_w
+    REAL, DIMENSION(klon)              :: yqsatsrf0_x, yqsatsrf0_w
+    REAL, DIMENSION(klon)              :: yqsurf_x, yqsurf_w
 !jyg<
 !!    REAL, DIMENSION(klon)              :: Kech_Hp, Kech_H_xp, Kech_H_wp
@@ -800,7 +837,7 @@
 !!    REAL, DIMENSION(klon)              :: Kech_Vp, Kech_V_xp, Kech_V_wp
 !>jyg
-!jyg<
-    REAL, DIMENSION(klon)              :: ah, bh     ! coefficients of the delta_Tsurf equation
-!>jyg
+
+    REAL                               :: fact_cdrag
+    REAL                               :: z1lay
 
     REAL                               :: vent
@@ -950,4 +987,5 @@
  fder_print(:)=0.
  zxqsurf(:)=0.
+ delta_qsurf(:) = 0.
  zxfluxu(:,:)=0. ; zxfluxv(:,:)=0.
  solsw(:,:)=0. ; sollw(:,:)=0.
@@ -1032,6 +1070,11 @@
     y_delta_flux_t1=0.
     ydtsurf_th=0.
-    yts_x=0.      ; yts_w=0.
-    y_delta_tsurf=0.
+    yts_x(:)=0.      ; yts_w(:)=0.
+    y_delta_tsurf(:)=0. ; y_delta_qsurf(:)=0.
+    yqsurf_x(:)=0.      ; yqsurf_w(:)=0.
+    yg_T(:) = 0. ;        yg_Q(:) = 0.
+    yGamma_dTs_phiT(:) = 0. ; yGamma_dQs_phiQ(:) = 0.
+    ydTs_ins(:) = 0. ; ydqs_ins(:) = 0.
+
 !!!
     ytsoil = 999999. 
@@ -1302,4 +1345,21 @@
 !****************************************************************************************
 
+!
+!jyg<    (20190926)
+!   Provisional : set ybeta to standard values
+       IF (nsrf .NE. is_ter) THEN
+           ybeta(:) = 1.
+       ELSE
+           IF (iflag_split .EQ. 0) THEN
+              ybeta(:) = 1.
+           ELSE
+             DO j = 1, knon
+                i = ni(j)
+                ybeta(j)   = beta(i,nsrf)
+             ENDDO
+           ENDIF  ! (iflag_split .LE.1)
+       ENDIF !  (nsrf .NE. is_ter)
+!>jyg
+!
        DO j = 1, knon
           i = ni(j)
@@ -1521,5 +1581,5 @@
         CALL cdrag(knon, nsrf, &
             speed_x, yt_x(:,1), yq_x(:,1), zgeo1_x, ypaprs(:,1),&
-            yts_x, yqsurf, yz0m, yz0h, &
+            yts_x, yqsurf_x, yz0m, yz0h, &
             ycdragm_x, ycdragh_x, zri1_x, pref_x )
 
@@ -1548,5 +1608,5 @@
         CALL cdrag(knon, nsrf, &
             speed_w, yt_w(:,1), yq_w(:,1), zgeo1_w, ypaprs(:,1),&
-            yts_w, yqsurf, yz0m, yz0h, &
+            yts_w, yqsurf_w, yz0m, yz0h, &
             ycdragm_w, ycdragh_w, zri1_w, pref_w )
 !
@@ -1621,5 +1681,5 @@
        ENDIF
         CALL coef_diff_turb(dtime, nsrf, knon, ni,  &
-            ypaprs, ypplay, yu_x, yv_x, yq_x, yt_x, yts_x, yqsurf, ycdragm_x, &
+            ypaprs, ypplay, yu_x, yv_x, yq_x, yt_x, yts_x, yqsurf_x, ycdragm_x, &
             ycoefm_x, ycoefh_x, ytke_x,y_treedrg)
 !            ycoefm_x, ycoefh_x, ytke_x)
@@ -1649,5 +1709,5 @@
        ENDIF
         CALL coef_diff_turb(dtime, nsrf, knon, ni,  &
-            ypaprs, ypplay, yu_w, yv_w, yq_w, yt_w, yts_w, yqsurf, ycdragm_w, &
+            ypaprs, ypplay, yu_w, yv_w, yq_w, yt_w, yts_w, yqsurf_w, ycdragm_w, &
             ycoefm_w, ycoefh_w, ytke_w,y_treedrg)
 !            ycoefm_w, ycoefh_w, ytke_w)
@@ -1786,77 +1846,110 @@
          yt1(:) = yt(:,1)
          yq1(:) = yq(:,1)
-!!       ELSE IF (iflag_split .eq. 1) THEN
-!!!
-!jyg<
-!!         CALL wx_pbl_fuse_no_dts(knon, dtime, ypplay, ywake_s, &
-!!                                 yt_x, yt_w, yq_x, yq_w, &
-!!                                 yu_x, yu_w, yv_x, yv_w, &
-!!                                 ycdragh_x, ycdragh_w, ycdragm_x, ycdragm_w, &
-!!                                 AcoefH_x, AcoefH_w, AcoefQ_x, AcoefQ_w, &
-!!                                 AcoefU_x, AcoefU_w, AcoefV_x, AcoefV_w, &
-!!                                 BcoefH_x, BcoefH_w, BcoefQ_x, BcoefQ_w, &
-!!                                 BcoefU_x, BcoefU_w, BcoefV_x, BcoefV_w, &
-!!                                 AcoefH, AcoefQ, AcoefU, AcoefV, &
-!!                                 BcoefH, BcoefQ, BcoefU, BcoefV, &
-!!                                 ycdragh, ycdragm, &
-!!                                 yt1, yq1, yu1, yv1 &
-!!                                 )
        ELSE IF (iflag_split .ge. 1) THEN
-         CALL wx_pbl0_fuse(knon, dtime, ypplay, ywake_s, &
+!
+! Cdragq computation
+! ------------------
+    !******************************************************************************
+    ! Cdragq computed from cdrag
+    ! The difference comes only from a factor (f_z0qh_oce) on z0, so that
+    ! it can be computed inside wx_pbl0_merge
+    ! More complicated appraches may require the propagation through
+    ! pbl_surface of an independant cdragq variable.
+    !******************************************************************************
+!
+    IF ( f_z0qh_oce .ne. 1. .and. nsrf .eq.is_oce) THEN
+       ! Si on suit les formulations par exemple de Tessel, on 
+       ! a z0h=0.4*nu/u*, z0q=0.62*nu/u*, d'ou f_z0qh_oce=0.62/0.4=1.55
+!!       ycdragq_x(1:knon)=ycdragh_x(1:knon)*                                      &
+!!            log(z1lay(1:knon)/yz0h(1:knon))/log(z1lay(1:knon)/(f_z0qh_oce*yz0h(1:knon)))
+!!       ycdragq_w(1:knon)=ycdragh_w(1:knon)*                                      &
+!!            log(z1lay(1:knon)/yz0h(1:knon))/log(z1lay(1:knon)/(f_z0qh_oce*yz0h(1:knon)))
+!
+       DO j = 1,knon
+         z1lay = zgeo1(j)/RG
+         fact_cdrag = log(z1lay/yz0h(j))/log(z1lay/(f_z0qh_oce*yz0h(j)))
+         ycdragq_x(j)=ycdragh_x(j)*fact_cdrag
+         ycdragq_w(j)=ycdragh_w(j)*fact_cdrag
+!!     Print *,'YYYYpbl0: fact_cdrag ', fact_cdrag
+       ENDDO  ! j = 1,knon
+!
+!!  Print *,'YYYYpbl0: z1lay, yz0h, f_z0qh_oce, ycdragh_w, ycdragq_w ', &
+!!                z1lay, yz0h(1:knon), f_z0qh_oce, ycdragh_w(1:knon), ycdragq_w(1:knon)
+    ELSE
+       ycdragq_x(1:knon)=ycdragh_x(1:knon)
+       ycdragq_w(1:knon)=ycdragh_w(1:knon)
+    ENDIF  ! ( f_z0qh_oce .ne. 1. .and. nsrf .eq.is_oce)
+!
+         CALL wx_pbl_prelim_0(knon, nsrf, dtime, ypplay, ypaprs, ywake_s,  &
+                         yts, y_delta_tsurf, ygustiness, &
                          yt_x, yt_w, yq_x, yq_w, &
                          yu_x, yu_w, yv_x, yv_w, &
-                         ycdragh_x, ycdragh_w, ycdragm_x, ycdragm_w, &
+                         ycdragh_x, ycdragh_w, ycdragq_x, ycdragq_w, &
+                         ycdragm_x, ycdragm_w, &
+                         AcoefH_x, AcoefH_w, AcoefQ_x, AcoefQ_w, &
+                         AcoefU_x, AcoefU_w, AcoefV_x, AcoefV_w, &
+                         BcoefH_x, BcoefH_w, BcoefQ_x, BcoefQ_w, &
+                         BcoefU_x, BcoefU_w, BcoefV_x, BcoefV_w  &
+                         )
+         CALL wx_pbl_prelim_beta(knon, dtime, ywake_s, ybeta,  &
+                         BcoefQ_x, BcoefQ_w  &
+                         )
+         CALL wx_pbl0_merge(knon, ypplay, ypaprs,  &
+                         ywake_s, ydTs0, ydqs0, &
+                         yt_x, yt_w, yq_x, yq_w, &
+                         yu_x, yu_w, yv_x, yv_w, &
+                         ycdragh_x, ycdragh_w, ycdragq_x, ycdragq_w, &
+                         ycdragm_x, ycdragm_w, &
                          AcoefH_x, AcoefH_w, AcoefQ_x, AcoefQ_w, &
                          AcoefU_x, AcoefU_w, AcoefV_x, AcoefV_w, &
                          BcoefH_x, BcoefH_w, BcoefQ_x, BcoefQ_w, &
                          BcoefU_x, BcoefU_w, BcoefV_x, BcoefV_w, &
-                         AcoefH, AcoefQ, AcoefU, AcoefV, &
-                         BcoefH, BcoefQ, BcoefU, BcoefV, &
-                         ycdragh, ycdragm, &
+                         AcoefH_0, AcoefQ_0, AcoefU, AcoefV, &
+                         BcoefH_0, BcoefQ_0, BcoefU, BcoefV, &
+                         ycdragh, ycdragq, ycdragm, &
                          yt1, yq1, yu1, yv1 &
                          )
-!!       ELSE IF (iflag_split .ge.2) THEN
-!!!    Provisoire
-!!         ah(:) = 0.
-!!         bh(:) = 0.
-!!         IF (nsrf == is_oce) THEN
-!!           ybeta(:) = 1.
-!!         ELSE
-!!           ybeta(:) = beta_land
-!!         ENDIF
-!!         ycdragh(:) = ywake_s(:)*ycdragh_w(:) + (1.-ywake_s(:))*ycdragh_x(:)
-!!         CALL wx_dts(knon, nsrf, ywake_cstar, ywake_s, ywake_dens, &
-!!                     yts, ypplay(:,1), ybeta, ycdragh , ypaprs(:,1), &
-!!                     yq(:,1), yt(:,1), yu(:,1), yv(:,1), ygustiness, &
-!!                     ah, bh &
-!!                     )
-!!!
-!!         CALL wx_pbl_fuse(knon, dtime, ypplay, ywake_s, &
-!!                         yt_x, yt_w, yq_x, yq_w, &
-!!                         yu_x, yu_w, yv_x, yv_w, &
-!!                         ycdragh_x, ycdragh_w, ycdragm_x, ycdragm_w, &
-!!                         AcoefH_x, AcoefH_w, AcoefQ_x, AcoefQ_w, &
-!!                         AcoefU_x, AcoefU_w, AcoefV_x, AcoefV_w, &
-!!                         BcoefH_x, BcoefH_w, BcoefQ_x, BcoefQ_w, &
-!!                         BcoefU_x, BcoefU_w, BcoefV_x, BcoefV_w, &
-!!                         ah, bh, &
-!!                         AcoefH, AcoefQ, AcoefU, AcoefV, &
-!!                         BcoefH, BcoefQ, BcoefU, BcoefV, &
-!!                         ycdragh, ycdragm, &
-!!                         yt1, yq1, yu1, yv1 &
-!!                         )
-!>jyg
-!!!
-         ENDIF  ! (iflag_split .eq.0)
+         IF (iflag_split .eq. 2 .AND. nsrf .ne. is_oce) THEN
+           CALL wx_pbl_dts_merge(knon, dtime, ypplay, ypaprs, &
+                           ywake_s, ybeta, ywake_cstar, ywake_dens, &
+                           AcoefH_x, AcoefH_w, &
+                           BcoefH_x, BcoefH_w, &
+                           AcoefH_0, AcoefQ_0, BcoefH_0, BcoefQ_0,  &
+                           AcoefH, AcoefQ, BcoefH, BcoefQ,  &
+                           HTphiT_b, dd_HTphiT, HTphiQ_b, dd_HTphiQ, HTRn_b, dd_HTRn, &
+                           phiT0_b, dphiT0, phiQ0_b, dphiQ0, Rn0_b, dRn0, &
+                           yg_T, yg_Q, &
+                           yGamma_dTs_phiT, yGamma_dQs_phiQ, &
+                           ydTs_ins, ydqs_ins &
+                           )
+         ELSE !
+           AcoefH(:) = AcoefH_0(:)
+           AcoefQ(:) = AcoefQ_0(:)
+           BcoefH(:) = BcoefH_0(:)
+           BcoefQ(:) = BcoefQ_0(:)
+           yg_T(:) = 0.
+           yg_Q(:) = 0.
+           yGamma_dTs_phiT(:) = 0.
+           yGamma_dQs_phiQ(:) = 0.
+           ydTs_ins(:) = 0.
+           ydqs_ins(:) = 0.
+         ENDIF   ! (iflag_split .eq. 2)
+       ENDIF  ! (iflag_split .eq.0)
 !!!
        IF (prt_level >=10) THEN
-         PRINT *,'pbl_surface (fuse->): yt(1,:) ',yt(1,:)
-         PRINT *,'pbl_surface (fuse->): yq(1,:) ',yq(1,:)
-         PRINT *,'pbl_surface (fuse->): yu(1,:) ',yu(1,:)
-         PRINT *,'pbl_surface (fuse->): yv(1,:) ',yv(1,:)
-         PRINT *,'pbl_surface (fuse->): AcoefH(1) ',AcoefH(1)
-         PRINT *,'pbl_surface (fuse->): BcoefH(1) ',BcoefH(1)
+         PRINT *,'pbl_surface (merge->): yt(1,:) ',yt(1,:)
+         PRINT *,'pbl_surface (merge->): yq(1,:) ',yq(1,:)
+         PRINT *,'pbl_surface (merge->): yu(1,:) ',yu(1,:)
+         PRINT *,'pbl_surface (merge->): yv(1,:) ',yv(1,:)
+         PRINT *,'pbl_surface (merge->): AcoefH(1), AcoefQ(1), AcoefU(1), AcoefV(1) ', &
+                                         AcoefH(1), AcoefQ(1), AcoefU(1), AcoefV(1)
+         PRINT *,'pbl_surface (merge->): BcoefH(1), BcoefQ(1), BcoefU(1), BcoefV(1) ', &
+                                         BcoefH(1), BcoefQ(1), BcoefU(1), BcoefV(1)
+
        ENDIF
 
+!  Save initial value of z0h for use in evappot (z0h wiil be computed again in the surface models)
+          yz0h_old(1:knon) = yz0h(1:knon)
+!
 !****************************************************************************************
 !
@@ -2117,35 +2210,102 @@
           y_flux_q1(j) = -yevap(j)
           ENDDO
-        ENDIF
-
-       IF (prt_level >=10) THEN
-        DO j=1,knon
-         print*,'y_flux_t1,yfluxlat,wakes' &
- &             ,  y_flux_t1(j), yfluxlat(j), ywake_s(j)
-         print*,'beta,ytsurf_new', ybeta(j), ytsurf_new(j)
-         print*,'inertia,facteur,cstar', inertia, facteur,wake_cstar(j)
-        ENDDO
-       ENDIF
-
-!!! jyg le 07/02/2012 puis le 10/04/2013
-!!       IF (iflag_split .eq.1) THEN
-!!!!!
-!!!jyg<
-!!         CALL wx_pbl_split_no_dts(knon, ywake_s, &
-!!                                AcoefH_x, AcoefH_w, &
-!!                                AcoefQ_x, AcoefQ_w, &
-!!                                AcoefU_x, AcoefU_w, &
-!!                                AcoefV_x, AcoefV_w, &
-!!                                y_flux_t1, y_flux_q1, y_flux_u1, y_flux_v1, &
-!!                                y_flux_t1_x, y_flux_t1_w, &
-!!                                y_flux_q1_x, y_flux_q1_w, &
-!!                                y_flux_u1_x, y_flux_u1_w, &
-!!                                y_flux_v1_x, y_flux_v1_w, &
-!!                                yfluxlat_x, yfluxlat_w &
-!!                                )
-!!       ELSE IF (iflag_split .ge. 2) THEN
+        ENDIF ! (ok_flux_surf)
+!
+! ------------------------------------------------------------------------------
+! 12a)  Splitting
+! ------------------------------------------------------------------------------
+
        IF (iflag_split .GE. 1) THEN
-         CALL wx_pbl0_split(knon, dtime, ywake_s, &
+!
+         IF (nsrf .ne. is_oce) THEN
+!
+!         Compute potential evaporation and aridity factor  (jyg, 20200328)
+          ybeta_prev(:) = ybeta(:)
+             DO j = 1, knon
+               yqa(j) = AcoefQ(j) - BcoefQ(j)*yevap(j)*dtime
+             ENDDO
+!
+          CALL wx_evappot(knon, yqa, yTsurf_new, yevap_pot)
+!
+          ybeta(1:knon) = min(yevap(1:knon)/yevap_pot(1:knon), 1.)
+          
+          IF (prt_level >=10) THEN
+           DO j=1,knon
+            print*,'y_flux_t1,yfluxlat,wakes' &
+ &                ,  y_flux_t1(j), yfluxlat(j), ywake_s(j)
+            print*,'beta_prev, beta, ytsurf_new', ybeta_prev(j), ybeta(j), ytsurf_new(j)
+            print*,'inertia,facteur,cstar', inertia, facteur,wake_cstar(j)
+           ENDDO
+          ENDIF  ! (prt_level >=10)
+!
+! Second call to wx_pbl0_merge and wx_pbl_dts_merge in order to take into account 
+! the update of the aridity coeficient beta.
+!
+        CALL wx_pbl_prelim_beta(knon, dtime, ywake_s, ybeta,  &
+                        BcoefQ_x, BcoefQ_w  &
+                        )
+        CALL wx_pbl0_merge(knon, ypplay, ypaprs,  &
+                          ywake_s, ydTs0, ydqs0, &
+                          yt_x, yt_w, yq_x, yq_w, &
+                          yu_x, yu_w, yv_x, yv_w, &
+                          ycdragh_x, ycdragh_w, ycdragq_x, ycdragq_w, &
+                          ycdragm_x, ycdragm_w, &
+                          AcoefH_x, AcoefH_w, AcoefQ_x, AcoefQ_w, &
+                          AcoefU_x, AcoefU_w, AcoefV_x, AcoefV_w, &
+                          BcoefH_x, BcoefH_w, BcoefQ_x, BcoefQ_w, &
+                          BcoefU_x, BcoefU_w, BcoefV_x, BcoefV_w, &
+                          AcoefH_0, AcoefQ_0, AcoefU, AcoefV, &
+                          BcoefH_0, BcoefQ_0, BcoefU, BcoefV, &
+                          ycdragh, ycdragq, ycdragm, &
+                          yt1, yq1, yu1, yv1 &
+                          )
+          IF (iflag_split .eq. 2) THEN
+            CALL wx_pbl_dts_merge(knon, dtime, ypplay, ypaprs, &
+                            ywake_s, ybeta, ywake_cstar, ywake_dens, &
+                            AcoefH_x, AcoefH_w, &
+                            BcoefH_x, BcoefH_w, &
+                            AcoefH_0, AcoefQ_0, BcoefH_0, BcoefQ_0,  &
+                            AcoefH, AcoefQ, BcoefH, BcoefQ,  &
+                            HTphiT_b, dd_HTphiT, HTphiQ_b, dd_HTphiQ, HTRn_b, dd_HTRn, &
+                            phiT0_b, dphiT0, phiQ0_b, dphiQ0, Rn0_b, dRn0, &
+                            yg_T, yg_Q, &
+                            yGamma_dTs_phiT, yGamma_dQs_phiQ, &
+                            ydTs_ins, ydqs_ins &
+                            )
+          ELSE !
+            AcoefH(:) = AcoefH_0(:)
+            AcoefQ(:) = AcoefQ_0(:)
+            BcoefH(:) = BcoefH_0(:)
+            BcoefQ(:) = BcoefQ_0(:)
+            yg_T(:) = 0.
+            yg_Q(:) = 0.
+            yGamma_dTs_phiT(:) = 0.
+            yGamma_dQs_phiQ(:) = 0.
+            ydTs_ins(:) = 0.
+            ydqs_ins(:) = 0.
+          ENDIF   ! (iflag_split .eq. 2)
+!
+        ELSE    ! (nsrf .ne. is_oce)
+          ybeta(1:knon) = 1.
+          yevap_pot(1:knon) = yevap(1:knon)
+          AcoefH(:) = AcoefH_0(:)
+          AcoefQ(:) = AcoefQ_0(:)
+          BcoefH(:) = BcoefH_0(:)
+          BcoefQ(:) = BcoefQ_0(:)
+          yg_T(:) = 0.
+          yg_Q(:) = 0.
+          yGamma_dTs_phiT(:) = 0.
+          yGamma_dQs_phiQ(:) = 0.
+          ydTs_ins(:) = 0.
+          ydqs_ins(:) = 0.
+        ENDIF   ! (nsrf .ne. is_oce)
+! 
+        CALL wx_pbl_split(knon, nsrf, dtime, ywake_s, ybeta, iflag_split, &
+                       yg_T, yg_Q, &
+                       yGamma_dTs_phiT, yGamma_dQs_phiQ, &
+                       ydTs_ins, ydqs_ins, &
                        y_flux_t1, y_flux_q1, y_flux_u1, y_flux_v1, &
+!!!!                       HTRn_b, dd_HTRn, HTphiT_b, dd_HTphiT, &
+                       phiQ0_b, phiT0_b, &
                        y_flux_t1_x, y_flux_t1_w, &
                        y_flux_q1_x, y_flux_q1_w, &
@@ -2153,7 +2313,49 @@
                        y_flux_v1_x, y_flux_v1_w, &
                        yfluxlat_x, yfluxlat_w, &
-                       y_delta_tsurf &
+                       y_delta_qsats, &
+                       y_delta_tsurf_new, y_delta_qsurf &
                        )
+!
+         CALL wx_pbl_check(knon, dtime, ypplay, ypaprs, ywake_s, ybeta, iflag_split, &
+                       yTs, y_delta_tsurf,  & 
+                       yqsurf, yTsurf_new,  &
+                       y_delta_tsurf_new, y_delta_qsats,  &
+                       AcoefH_x, AcoefH_w, &
+                       BcoefH_x, BcoefH_w, &
+                       AcoefH_0, AcoefQ_0, BcoefH_0, BcoefQ_0,  &
+                       AcoefH, AcoefQ, BcoefH, BcoefQ,  &
+                       y_flux_t1, y_flux_q1,  &
+                       y_flux_t1_x, y_flux_t1_w, &
+                       y_flux_q1_x, y_flux_q1_w)
+!
+         IF (nsrf .ne. is_oce) THEN
+           CALL wx_pbl_dts_check(knon, dtime, ypplay, ypaprs, ywake_s, ybeta, iflag_split, &
+                         yTs, y_delta_tsurf,  & 
+                         yqsurf, yTsurf_new,  &
+                         y_delta_qsats, y_delta_tsurf_new, y_delta_qsurf,  &
+                         AcoefH_x, AcoefH_w, &
+                         BcoefH_x, BcoefH_w, &
+                         AcoefH_0, AcoefQ_0, BcoefH_0, BcoefQ_0,  &
+                         AcoefH, AcoefQ, BcoefH, BcoefQ,  &
+                         HTphiT_b, dd_HTphiT, HTphiQ_b, dd_HTphiQ, HTRn_b, dd_HTRn, &
+                         phiT0_b, dphiT0, phiQ0_b, dphiQ0, Rn0_b, dRn0, &
+                         yg_T, yg_Q, &
+                         yGamma_dTs_phiT, yGamma_dQs_phiQ, &
+                         ydTs_ins, ydqs_ins, &
+                         y_flux_t1, y_flux_q1,  &
+                         y_flux_t1_x, y_flux_t1_w, &
+                         y_flux_q1_x, y_flux_q1_w )
+         ENDIF   ! (nsrf .ne. is_oce)
+!
+       ELSE  ! (iflag_split .ge. 1)
+         ybeta(1:knon) = 1.
+         yevap_pot(1:knon) = yevap(1:knon)
        ENDIF  ! (iflag_split .ge. 1)
+!
+       IF (prt_level >= 10) THEN
+         print *,'pbl_surface, ybeta , yevap, yevap_pot ', &
+                               ybeta , yevap, yevap_pot
+       ENDIF  ! (prt_level >= 10)
+!
 !>jyg
 !
@@ -2318,10 +2520,10 @@
        ENDIF  ! (iflag_split .eq.0)
 !!!
-
-        DO j = 1, knon
-          y_dflux_t(j) = y_dflux_t(j) * ypct(j)
-          y_dflux_q(j) = y_dflux_q(j) * ypct(j)
-        ENDDO
-
+!!
+!!        DO j = 1, knon
+!!          y_dflux_t(j) = y_dflux_t(j) * ypct(j)
+!!          y_dflux_q(j) = y_dflux_q(j) * ypct(j)
+!!        ENDDO
+!!
 !****************************************************************************************
 ! 13) Transform variables for output format : 
@@ -2438,4 +2640,5 @@
           i = ni(j)
           evap(i,nsrf) = - flux_q(i,1,nsrf)                  !jyg
+          beta(i,nsrf) = ybeta(j)                             !jyg
           d_ts(i,nsrf) = y_d_ts(j)
 !albedo SB >>>
@@ -2453,6 +2656,6 @@
           cdragh(i) = cdragh(i) + ycdragh(j)*ypct(j)
           cdragm(i) = cdragm(i) + ycdragm(j)*ypct(j)
-          dflux_t(i) = dflux_t(i) + y_dflux_t(j)
-          dflux_q(i) = dflux_q(i) + y_dflux_q(j)
+          dflux_t(i) = dflux_t(i) + y_dflux_t(j)*ypct(j)
+          dflux_q(i) = dflux_q(i) + y_dflux_q(j)*ypct(j)
        ENDDO
 
@@ -2470,5 +2673,8 @@
 !!! nrlmd le 13/06/2011
 !!jyg20170131          delta_tsurf(i,nsrf)=y_delta_tsurf(j)*ypct(j)
-          delta_tsurf(i,nsrf)=y_delta_tsurf(j)
+!!jyg20210118          delta_tsurf(i,nsrf)=y_delta_tsurf(j)
+          delta_tsurf(i,nsrf)=y_delta_tsurf_new(j)
+!
+          delta_qsurf(i) = delta_qsurf(i) + y_delta_qsurf(j)*ypct(j)
 !
           cdragh_x(i) = cdragh_x(i) + ycdragh_x(j)*ypct(j)
@@ -2671,5 +2877,6 @@
                * (ypaprs(j,1)-ypplay(j,1))
           tairsol(j) = yts(j) + y_d_ts(j)
-          tairsol_x(j) = tairsol(j) - ywake_s(j)*y_delta_tsurf(j)
+!!          tairsol_x(j) = tairsol(j) - ywake_s(j)*y_delta_tsurf(j)
+          tairsol_x(j) = tairsol(j) - ywake_s(j)*y_delta_tsurf_new(j)
           qairsol(j) = yqsurf(j)
         ENDDO
@@ -3268,4 +3475,6 @@
     IF (ALLOCATED(qsurf)) DEALLOCATE(qsurf)
     IF (ALLOCATED(ftsoil)) DEALLOCATE(ftsoil)
+    IF (ALLOCATED(ydTs0)) DEALLOCATE(ydTs0)
+    IF (ALLOCATED(ydqs0)) DEALLOCATE(ydqs0)
 
 !jyg<
Index: /LMDZ6/trunk/libf/phylmd/phyredem.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/phyredem.F90	(revision 3887)
+++ /LMDZ6/trunk/libf/phylmd/phyredem.F90	(revision 3888)
@@ -12,5 +12,6 @@
   USE fonte_neige_mod,  ONLY : fonte_neige_final
   USE pbl_surface_mod,  ONLY : pbl_surface_final
-  USE phys_state_var_mod, ONLY: radpas, zmasq, pctsrf, ftsol, falb_dir,      &
+  USE phys_state_var_mod, ONLY: radpas, zmasq, pctsrf,                       &
+                                ftsol, beta_aridity, delta_tsurf, falb_dir,  &
                                 falb_dif, qsol, fevap, radsol, solsw, sollw, &
                                 sollwdown, rain_fall, snow_fall, z0m, z0h,   &
@@ -157,5 +158,11 @@
     END IF
 
+!    Surface variables 
     CALL put_field_srf1(pass,"TS","Temperature",ftsol(:,:))
+
+    CALL put_field_srf1(pass,"DELTA_TS","w-x surface temperature difference", delta_tsurf(:,:))
+
+    CALL put_field_srf1(pass,"BETA_S","Aridity factor", beta_aridity(:,:))
+!    End surface variables
 
 ! ================== Albedo =======================================
Index: /LMDZ6/trunk/libf/phylmd/phys_local_var_mod.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/phys_local_var_mod.F90	(revision 3887)
+++ /LMDZ6/trunk/libf/phylmd/phys_local_var_mod.F90	(revision 3888)
@@ -340,4 +340,6 @@
       REAL,ALLOCATABLE,SAVE,DIMENSION(:) :: zxfluxlat_x, zxfluxlat_w
 !$OMP THREADPRIVATE(zxfluxlat_x, zxfluxlat_w)
+      REAL,ALLOCATABLE,SAVE,DIMENSION(:) :: delta_qsurf
+!$OMP THREADPRIVATE(delta_qsurf)
 !jyg<
 !!! Entrees supplementaires couche-limite
@@ -733,4 +735,5 @@
       ALLOCATE(sens_x(klon), sens_w(klon))
       ALLOCATE(zxfluxlat_x(klon), zxfluxlat_w(klon))
+      ALLOCATE(delta_qsurf(klon))
 !jyg<
 !!      ALLOCATE(t_x(klon,klev), t_w(klon,klev))
@@ -1032,4 +1035,5 @@
       DEALLOCATE(sens_x, sens_w)
       DEALLOCATE(zxfluxlat_x, zxfluxlat_w)
+      DEALLOCATE(delta_qsurf)
 !jyg<
 !!      DEALLOCATE(t_x, t_w)
